/* Author: Brandon Keith
 * Date: 09/12/13
 * Course: CIS 2168 (Data Structures)
 * Teaching Assistant: Min Xiao 
 * Description: This program randomly scrambles the middle letters of the 
 *              words in a text file or a webpage. Only words that are four 
 *              letters long or greater are considered for scrambling. 
 */

package lab_01_scramble_file;

import java.net.*;
import java.io.*;
import java.util.Scanner;
import java.util.Random;
import java.lang.String;

public class File_Scrambler {

    public static void main(String[] args) throws Exception {
        
        Scanner scancmd = new Scanner(System.in);   
        String option;
        String text;
        TextFileScrambler scrambler01 = new TextFileScrambler();

        while(true){
            System.out.println("\nWelcome to Word File scrambling.");
            System.out.println("Enter:");
            System.out.println("(a) scramble text file");
            System.out.println("(b) scramble text in URL");
            System.out.println("(c) exit program");

            option = scancmd.nextLine();

            if(option.matches("a")){
                text = scrambler01.scramble_textfile();
                scrambler01.text_scrambler(option, text);
            }
            else if(option.matches("b")){
                text = scrambler01.scramble_webpage();
                scrambler01.text_scrambler(option, text);
            }
            else if(option.matches("c")){
                System.exit(1);
            }
            else{
                System.out.println("What?");
            }
        } // end infinite while loop
    } // end main program
} // end public File_Scrambler class

    class TextFileScrambler{
        char option;
        boolean found;
        boolean emptyspot;
        int word_length;
        int randnum;
        int counter;
        String textfile;
        String full_text;
        String inputLine;
        String finalString;
        String[] split_text;
        char[] temp;
        Scanner scancmd;
        Scanner scantxt;
        FileReader reader;
        Random randgen;
        Writer write_file;
        StringBuilder full;
        
        String scramble_textfile () throws IOException {
            
            scancmd = new Scanner(System.in);
            
            while(found == false){
                
                found = true;
                
                // input text file name
                System.out.println("Enter name of text file (.txt):");
                textfile = scancmd.nextLine();
                
                try {
                    reader = new FileReader(textfile);
                }
                catch(FileNotFoundException e) {
                    found = false;
                    System.out.println("\nError: File '"+ textfile +"' cannot be found. Please correct.");
                }
            } // end while loop
            
            found = false;
            
            // read text file
            scantxt = new Scanner(new BufferedReader(reader));
            full_text = scantxt.nextLine();
            
            return full_text;
        } // end scramble_textfile
        
        String scramble_webpage () throws IOException{
            
            scancmd = new Scanner(System.in);
            
                while(found == false){
                
                    found = true;
                
                    // input text file name
                    System.out.println("Enter URL (www):");
                    textfile = scancmd.nextLine();
                
                    try {
                        URL oracle = new URL(textfile);
                        BufferedReader in = new BufferedReader(
                        new InputStreamReader(oracle.openStream()));
                        full = new StringBuilder();
                        while ((inputLine = in.readLine()) != null){
                            full.append(inputLine);
                        }
                        finalString = full.toString();
                        in.close();
                    }
                    catch(MalformedURLException e) {
                        found = false;
                        System.out.println("\nError: The URL '"+ textfile +"' cannot be found. Please correct.");
                    }
                } // end while loop
                
                found = false;
               
                return finalString;
        } // end scramble_webpage
        
        void text_scrambler(String a, String text){
            
            full_text = text;
            
            // split text into array of words
            split_text = full_text.split("\\s+");
           
             if(a.matches("a")){
                 // parse through words in array
                 for(int i = 0; i < split_text.length; i++){
                
                    // deal with words that are four letters long or greater
                    if(split_text[i].length() >= 4){
                        // get word length
                        word_length = split_text[i].length();
                        // store word as array of characters
                        temp = split_text[i].toCharArray();
                        // zero out center letters (e.g. should becomes s000d)
                        for(int j = 1; j <= (word_length - 2); j++){
                            temp[j] = '0';
                        }
                    
                        // word scramble logic
                        for(int k = 1; k <= (word_length - 2); k++){
                            emptyspot = false;
                            randgen = new Random();
                            // making sure not to write to same place in temp twice 
                            while(emptyspot == false){
                                randnum = randgen.nextInt(word_length - 2) + 1;
                                if(temp[randnum] == '0'){
                                    emptyspot = true;
                                }
                            } // end while loop
                            // write letter in word to random place in temp
                            temp[randnum] = split_text[i].charAt(k);
                        } // end for loop
                    
                        // store scrambled array of characters into string
                        split_text[i] = new String(temp);
                    } // end if statement
                } // end for loop
            
                // generate random text file name
                randgen = new Random();
                randnum = randgen.nextInt(1000000);
                textfile = "scrambled_file_" + Integer.toString(randnum) + ".txt";
           
                write_file = null;
                // create new text file
                try{
                    write_file = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(textfile), "utf-8"));
                
                    // write scrambled text to file
                    for(int i = 0; i < split_text.length; i++){
                        write_file.write(split_text[i] + " ");
                    }
                    write_file.close();
                    System.out.println("\nscrambled text file: " + textfile + "\n(check" 
                    + " Netbeans project directory)");
   
                } catch (IOException fi){
                    System.err.println("Error: " + fi.getMessage());
                  }
           } // end if for text file scrambler 
           else if (a.matches("b")){
               // parse through words in array
                for(int i = 0; i < split_text.length; i++){
                
                    // deal with words that are four letters long or greater
                    if(split_text[i].length() >= 4){
                        if(split_text[i].matches(".*[^A-Za-z].*") == true){
                           // do nothing 
                        }
                        else{
                            // get word length
                            word_length = split_text[i].length();
                            // store word as array of characters
                            temp = split_text[i].toCharArray();
                        
                            // zero out center letters (e.g. should becomes s000d)
                            for(int j = 1; j <= (word_length - 2); j++){
                                temp[j] = '0';
                            }
                    
                            // word scramble logic
                            for(int k = 1; k <= (word_length - 2); k++){
                                emptyspot = false;
                                randgen = new Random();
                                // making sure not to write to same place in temp twice 
                                while(emptyspot == false){
                                    randnum = randgen.nextInt(word_length - 2) + 1;
                                    if(temp[randnum] == '0'){
                                        emptyspot = true;
                                    }
                                } // end while loop
                                // write letter in word to random place in temp
                                temp[randnum] = split_text[i].charAt(k);
                            } // end for loop
                    
                            // store scrambled array of characters into string
                            split_text[i] = new String(temp);
                            
                        } // end else statement
                     } // end if statement
                 } // end for loop
                
                // generate random text file name
                randgen = new Random();
                randnum = randgen.nextInt(1000000);
                textfile = "scrambled_file_" + Integer.toString(randnum) + ".html";
           
                write_file = null;
                // create new text file
                try{
                    write_file = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(textfile), "utf-8"));
                
                    // write scrambled text to file
                    for(int i = 0; i < split_text.length; i++){
                    write_file.write(split_text[i] + " ");
                    }
                    write_file.close();
                    System.out.println("\nscrambled HTML file: " + textfile + "\n(check" 
                    + " Netbeans project directory)");
   
                } catch (IOException fi){
                    System.err.println("Error: " + fi.getMessage());
                  }
           } // end if for scramble webpage case
            
        } // end text_scrambler method
                
    } // end TextFileScrambler class
    
        